Index: trunk/src/VBox/GuestHost/OpenGL/packer/pack_program.c
===================================================================
--- trunk/src/VBox/GuestHost/OpenGL/packer/pack_program.c	(revision 66606)
+++ trunk/src/VBox/GuestHost/OpenGL/packer/pack_program.c	(revision 66609)
@@ -18,5 +18,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     int packet_length = sizeof(int) + sizeof(target) + sizeof(index) + sizeof(num) + num * 4 * sizeof(GLdouble);
 
@@ -36,5 +36,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     int packet_length = sizeof(int) + sizeof(target) + sizeof(index) + sizeof(num) + num * 4 * sizeof(GLfloat);
 
@@ -162,5 +162,5 @@
 {
     const int packet_length = 32;
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_PACKER_CONTEXT(pc);
 
@@ -181,5 +181,5 @@
 {
     const int packet_length = 20 + len;
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_PACKER_CONTEXT(pc);
 
@@ -208,5 +208,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     int packet_length = 32 + len;
 
@@ -228,5 +228,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     int packet_length = 48 + len;
 
@@ -263,5 +263,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     int packet_length;
 
@@ -291,5 +291,5 @@
     int packet_length = 32 + len;
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_BUFFERED_POINTER(pc, packet_length);
     WRITE_DATA(0, GLint, packet_length);
@@ -309,5 +309,5 @@
     int packet_length = 32 + len;
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_BUFFERED_POINTER(pc, packet_length);
     WRITE_DATA(0, GLint, packet_length);
@@ -326,5 +326,5 @@
 void PACK_APIENTRY crPackDeleteProgramsARB(GLsizei n, const GLuint *ids)
 {
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     int packet_length = sizeof(GLenum) + sizeof(n) + n * sizeof(*ids);
 
@@ -344,5 +344,5 @@
 {
     const int packet_length = 20 + len;
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_PACKER_CONTEXT(pc);
 
@@ -367,5 +367,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_BUFFERED_POINTER(pc, 8);
     pc->current.c.vertexAttrib.b4[index] = data_ptr + 4;
@@ -383,5 +383,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_BUFFERED_POINTER(pc, 20);
     pc->current.c.vertexAttrib.i4[index] = data_ptr + 4;
@@ -399,5 +399,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_BUFFERED_POINTER(pc, 12);
     pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
@@ -415,5 +415,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_BUFFERED_POINTER(pc, 8);
     pc->current.c.vertexAttrib.ub4[index] = data_ptr + 4;
@@ -431,5 +431,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_BUFFERED_POINTER(pc, 20);
     pc->current.c.vertexAttrib.ui4[index] = data_ptr + 4;
@@ -447,5 +447,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_BUFFERED_POINTER(pc, 12);
     pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
@@ -463,5 +463,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_BUFFERED_POINTER(pc, 8);
     pc->current.c.vertexAttrib.b4[index] = data_ptr + 4;
@@ -479,5 +479,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_BUFFERED_POINTER(pc, 20);
     pc->current.c.vertexAttrib.i4[index] = data_ptr + 4;
@@ -495,5 +495,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_BUFFERED_POINTER(pc, 20);
     pc->current.c.vertexAttrib.ui4[index] = data_ptr + 4;
@@ -511,5 +511,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_BUFFERED_POINTER(pc, 12);
     pc->current.c.vertexAttrib.s4[index] = data_ptr + 4;
@@ -528,5 +528,5 @@
 {
     CR_GET_PACKER_CONTEXT(pc);
-    unsigned char *data_ptr;
+    unsigned char *data_ptr = NULL;
     CR_GET_BUFFERED_POINTER(pc, 8);
     pc->current.c.vertexAttrib.ub4[index] = data_ptr + 4;